#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private SymmDotsNT8[] cacheSymmDotsNT8;
		private SymmOuterEdgeIndiNT8[] cacheSymmOuterEdgeIndiNT8;
		private SymmProfileNT8[] cacheSymmProfileNT8;
		private SymmSpplyDemndLnNT8[] cacheSymmSpplyDemndLnNT8;

		
		public SymmDotsNT8 SymmDotsNT8(int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			return SymmDotsNT8(Input, numTicks, numCloses, barsBack, pivotStrength);
		}

		public SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			return SymmOuterEdgeIndiNT8(Input, trend, speedPeriod, speedCandles, aTRTrailTicks, aTRTrailTicks2, slingShot, failure, alert, periodD1, periodK1, smooth1, overbought1, oversold1, periodD2, periodK2, smooth2, overbought2, oversold2, overbought3, oversold3, overbought4, oversold4);
		}

		public SymmProfileNT8 SymmProfileNT8(int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			return SymmProfileNT8(Input, mP_RTHBeginTime, mP_RTHEndTime, mP_PlotETH, mP_ETHBeginTime, mP_ETHEndTime, mP_MPSessionType, mP_TPOSize, mP_ShowBars, drawPOC2, valueAreaSize, pOCVAHColor, vAHDashStyle, vAHWidth, pOCColor, pOCDashStyle, pOCWidth, pOCVALColor, vALDashStyle, vALWidth);
		}

		public SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(bool showPrices)
		{
			return SymmSpplyDemndLnNT8(Input, showPrices);
		}


		
		public SymmDotsNT8 SymmDotsNT8(ISeries<double> input, int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			if (cacheSymmDotsNT8 != null)
				for (int idx = 0; idx < cacheSymmDotsNT8.Length; idx++)
					if (cacheSymmDotsNT8[idx].NumTicks == numTicks && cacheSymmDotsNT8[idx].NumCloses == numCloses && cacheSymmDotsNT8[idx].BarsBack == barsBack && cacheSymmDotsNT8[idx].PivotStrength == pivotStrength && cacheSymmDotsNT8[idx].EqualsInput(input))
						return cacheSymmDotsNT8[idx];
			return CacheIndicator<SymmDotsNT8>(new SymmDotsNT8(){ NumTicks = numTicks, NumCloses = numCloses, BarsBack = barsBack, PivotStrength = pivotStrength }, input, ref cacheSymmDotsNT8);
		}

		public SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(ISeries<double> input, BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			if (cacheSymmOuterEdgeIndiNT8 != null)
				for (int idx = 0; idx < cacheSymmOuterEdgeIndiNT8.Length; idx++)
					if (cacheSymmOuterEdgeIndiNT8[idx].Trend == trend && cacheSymmOuterEdgeIndiNT8[idx].SpeedPeriod == speedPeriod && cacheSymmOuterEdgeIndiNT8[idx].SpeedCandles == speedCandles && cacheSymmOuterEdgeIndiNT8[idx].ATRTrailTicks == aTRTrailTicks && cacheSymmOuterEdgeIndiNT8[idx].ATRTrailTicks2 == aTRTrailTicks2 && cacheSymmOuterEdgeIndiNT8[idx].SlingShot == slingShot && cacheSymmOuterEdgeIndiNT8[idx].Failure == failure && cacheSymmOuterEdgeIndiNT8[idx].Alert == alert && cacheSymmOuterEdgeIndiNT8[idx].PeriodD1 == periodD1 && cacheSymmOuterEdgeIndiNT8[idx].PeriodK1 == periodK1 && cacheSymmOuterEdgeIndiNT8[idx].Smooth1 == smooth1 && cacheSymmOuterEdgeIndiNT8[idx].Overbought1 == overbought1 && cacheSymmOuterEdgeIndiNT8[idx].Oversold1 == oversold1 && cacheSymmOuterEdgeIndiNT8[idx].PeriodD2 == periodD2 && cacheSymmOuterEdgeIndiNT8[idx].PeriodK2 == periodK2 && cacheSymmOuterEdgeIndiNT8[idx].Smooth2 == smooth2 && cacheSymmOuterEdgeIndiNT8[idx].Overbought2 == overbought2 && cacheSymmOuterEdgeIndiNT8[idx].Oversold2 == oversold2 && cacheSymmOuterEdgeIndiNT8[idx].Overbought3 == overbought3 && cacheSymmOuterEdgeIndiNT8[idx].Oversold3 == oversold3 && cacheSymmOuterEdgeIndiNT8[idx].Overbought4 == overbought4 && cacheSymmOuterEdgeIndiNT8[idx].Oversold4 == oversold4 && cacheSymmOuterEdgeIndiNT8[idx].EqualsInput(input))
						return cacheSymmOuterEdgeIndiNT8[idx];
			return CacheIndicator<SymmOuterEdgeIndiNT8>(new SymmOuterEdgeIndiNT8(){ Trend = trend, SpeedPeriod = speedPeriod, SpeedCandles = speedCandles, ATRTrailTicks = aTRTrailTicks, ATRTrailTicks2 = aTRTrailTicks2, SlingShot = slingShot, Failure = failure, Alert = alert, PeriodD1 = periodD1, PeriodK1 = periodK1, Smooth1 = smooth1, Overbought1 = overbought1, Oversold1 = oversold1, PeriodD2 = periodD2, PeriodK2 = periodK2, Smooth2 = smooth2, Overbought2 = overbought2, Oversold2 = oversold2, Overbought3 = overbought3, Oversold3 = oversold3, Overbought4 = overbought4, Oversold4 = oversold4 }, input, ref cacheSymmOuterEdgeIndiNT8);
		}

		public SymmProfileNT8 SymmProfileNT8(ISeries<double> input, int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			if (cacheSymmProfileNT8 != null)
				for (int idx = 0; idx < cacheSymmProfileNT8.Length; idx++)
					if (cacheSymmProfileNT8[idx].MP_RTHBeginTime == mP_RTHBeginTime && cacheSymmProfileNT8[idx].MP_RTHEndTime == mP_RTHEndTime && cacheSymmProfileNT8[idx].MP_PlotETH == mP_PlotETH && cacheSymmProfileNT8[idx].MP_ETHBeginTime == mP_ETHBeginTime && cacheSymmProfileNT8[idx].MP_ETHEndTime == mP_ETHEndTime && cacheSymmProfileNT8[idx].MP_MPSessionType == mP_MPSessionType && cacheSymmProfileNT8[idx].MP_TPOSize == mP_TPOSize && cacheSymmProfileNT8[idx].MP_ShowBars == mP_ShowBars && cacheSymmProfileNT8[idx].DrawPOC2 == drawPOC2 && cacheSymmProfileNT8[idx].ValueAreaSize == valueAreaSize && cacheSymmProfileNT8[idx].POCVAHColor == pOCVAHColor && cacheSymmProfileNT8[idx].VAHDashStyle == vAHDashStyle && cacheSymmProfileNT8[idx].VAHWidth == vAHWidth && cacheSymmProfileNT8[idx].POCColor == pOCColor && cacheSymmProfileNT8[idx].POCDashStyle == pOCDashStyle && cacheSymmProfileNT8[idx].POCWidth == pOCWidth && cacheSymmProfileNT8[idx].POCVALColor == pOCVALColor && cacheSymmProfileNT8[idx].VALDashStyle == vALDashStyle && cacheSymmProfileNT8[idx].VALWidth == vALWidth && cacheSymmProfileNT8[idx].EqualsInput(input))
						return cacheSymmProfileNT8[idx];
			return CacheIndicator<SymmProfileNT8>(new SymmProfileNT8(){ MP_RTHBeginTime = mP_RTHBeginTime, MP_RTHEndTime = mP_RTHEndTime, MP_PlotETH = mP_PlotETH, MP_ETHBeginTime = mP_ETHBeginTime, MP_ETHEndTime = mP_ETHEndTime, MP_MPSessionType = mP_MPSessionType, MP_TPOSize = mP_TPOSize, MP_ShowBars = mP_ShowBars, DrawPOC2 = drawPOC2, ValueAreaSize = valueAreaSize, POCVAHColor = pOCVAHColor, VAHDashStyle = vAHDashStyle, VAHWidth = vAHWidth, POCColor = pOCColor, POCDashStyle = pOCDashStyle, POCWidth = pOCWidth, POCVALColor = pOCVALColor, VALDashStyle = vALDashStyle, VALWidth = vALWidth }, input, ref cacheSymmProfileNT8);
		}

		public SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(ISeries<double> input, bool showPrices)
		{
			if (cacheSymmSpplyDemndLnNT8 != null)
				for (int idx = 0; idx < cacheSymmSpplyDemndLnNT8.Length; idx++)
					if (cacheSymmSpplyDemndLnNT8[idx].ShowPrices == showPrices && cacheSymmSpplyDemndLnNT8[idx].EqualsInput(input))
						return cacheSymmSpplyDemndLnNT8[idx];
			return CacheIndicator<SymmSpplyDemndLnNT8>(new SymmSpplyDemndLnNT8(){ ShowPrices = showPrices }, input, ref cacheSymmSpplyDemndLnNT8);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.SymmDotsNT8 SymmDotsNT8(int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			return indicator.SymmDotsNT8(Input, numTicks, numCloses, barsBack, pivotStrength);
		}

		public Indicators.SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			return indicator.SymmOuterEdgeIndiNT8(Input, trend, speedPeriod, speedCandles, aTRTrailTicks, aTRTrailTicks2, slingShot, failure, alert, periodD1, periodK1, smooth1, overbought1, oversold1, periodD2, periodK2, smooth2, overbought2, oversold2, overbought3, oversold3, overbought4, oversold4);
		}

		public Indicators.SymmProfileNT8 SymmProfileNT8(int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			return indicator.SymmProfileNT8(Input, mP_RTHBeginTime, mP_RTHEndTime, mP_PlotETH, mP_ETHBeginTime, mP_ETHEndTime, mP_MPSessionType, mP_TPOSize, mP_ShowBars, drawPOC2, valueAreaSize, pOCVAHColor, vAHDashStyle, vAHWidth, pOCColor, pOCDashStyle, pOCWidth, pOCVALColor, vALDashStyle, vALWidth);
		}

		public Indicators.SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(bool showPrices)
		{
			return indicator.SymmSpplyDemndLnNT8(Input, showPrices);
		}


		
		public Indicators.SymmDotsNT8 SymmDotsNT8(ISeries<double> input , int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			return indicator.SymmDotsNT8(input, numTicks, numCloses, barsBack, pivotStrength);
		}

		public Indicators.SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(ISeries<double> input , BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			return indicator.SymmOuterEdgeIndiNT8(input, trend, speedPeriod, speedCandles, aTRTrailTicks, aTRTrailTicks2, slingShot, failure, alert, periodD1, periodK1, smooth1, overbought1, oversold1, periodD2, periodK2, smooth2, overbought2, oversold2, overbought3, oversold3, overbought4, oversold4);
		}

		public Indicators.SymmProfileNT8 SymmProfileNT8(ISeries<double> input , int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			return indicator.SymmProfileNT8(input, mP_RTHBeginTime, mP_RTHEndTime, mP_PlotETH, mP_ETHBeginTime, mP_ETHEndTime, mP_MPSessionType, mP_TPOSize, mP_ShowBars, drawPOC2, valueAreaSize, pOCVAHColor, vAHDashStyle, vAHWidth, pOCColor, pOCDashStyle, pOCWidth, pOCVALColor, vALDashStyle, vALWidth);
		}

		public Indicators.SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(ISeries<double> input , bool showPrices)
		{
			return indicator.SymmSpplyDemndLnNT8(input, showPrices);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.SymmDotsNT8 SymmDotsNT8(int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			return indicator.SymmDotsNT8(Input, numTicks, numCloses, barsBack, pivotStrength);
		}

		public Indicators.SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			return indicator.SymmOuterEdgeIndiNT8(Input, trend, speedPeriod, speedCandles, aTRTrailTicks, aTRTrailTicks2, slingShot, failure, alert, periodD1, periodK1, smooth1, overbought1, oversold1, periodD2, periodK2, smooth2, overbought2, oversold2, overbought3, oversold3, overbought4, oversold4);
		}

		public Indicators.SymmProfileNT8 SymmProfileNT8(int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			return indicator.SymmProfileNT8(Input, mP_RTHBeginTime, mP_RTHEndTime, mP_PlotETH, mP_ETHBeginTime, mP_ETHEndTime, mP_MPSessionType, mP_TPOSize, mP_ShowBars, drawPOC2, valueAreaSize, pOCVAHColor, vAHDashStyle, vAHWidth, pOCColor, pOCDashStyle, pOCWidth, pOCVALColor, vALDashStyle, vALWidth);
		}

		public Indicators.SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(bool showPrices)
		{
			return indicator.SymmSpplyDemndLnNT8(Input, showPrices);
		}


		
		public Indicators.SymmDotsNT8 SymmDotsNT8(ISeries<double> input , int numTicks, int numCloses, int barsBack, int pivotStrength)
		{
			return indicator.SymmDotsNT8(input, numTicks, numCloses, barsBack, pivotStrength);
		}

		public Indicators.SymmOuterEdgeIndiNT8 SymmOuterEdgeIndiNT8(ISeries<double> input , BarsPeriod trend, int speedPeriod, int speedCandles, int aTRTrailTicks, int aTRTrailTicks2, bool slingShot, bool failure, string alert, int periodD1, int periodK1, int smooth1, double overbought1, double oversold1, int periodD2, int periodK2, int smooth2, double overbought2, double oversold2, double overbought3, double oversold3, double overbought4, double oversold4)
		{
			return indicator.SymmOuterEdgeIndiNT8(input, trend, speedPeriod, speedCandles, aTRTrailTicks, aTRTrailTicks2, slingShot, failure, alert, periodD1, periodK1, smooth1, overbought1, oversold1, periodD2, periodK2, smooth2, overbought2, oversold2, overbought3, oversold3, overbought4, oversold4);
		}

		public Indicators.SymmProfileNT8 SymmProfileNT8(ISeries<double> input , int mP_RTHBeginTime, int mP_RTHEndTime, bool mP_PlotETH, int mP_ETHBeginTime, int mP_ETHEndTime, SessionType mP_MPSessionType, int mP_TPOSize, bool mP_ShowBars, bool drawPOC2, int valueAreaSize, Brush pOCVAHColor, DashStyleHelper vAHDashStyle, Int32 vAHWidth, Brush pOCColor, DashStyleHelper pOCDashStyle, Int32 pOCWidth, Brush pOCVALColor, DashStyleHelper vALDashStyle, Int32 vALWidth)
		{
			return indicator.SymmProfileNT8(input, mP_RTHBeginTime, mP_RTHEndTime, mP_PlotETH, mP_ETHBeginTime, mP_ETHEndTime, mP_MPSessionType, mP_TPOSize, mP_ShowBars, drawPOC2, valueAreaSize, pOCVAHColor, vAHDashStyle, vAHWidth, pOCColor, pOCDashStyle, pOCWidth, pOCVALColor, vALDashStyle, vALWidth);
		}

		public Indicators.SymmSpplyDemndLnNT8 SymmSpplyDemndLnNT8(ISeries<double> input , bool showPrices)
		{
			return indicator.SymmSpplyDemndLnNT8(input, showPrices);
		}

	}
}

#endregion
